## gecode 4.2.0

=== CMakeLists.txt ===
#
#  Main authors:
#     Victor Zverovich <victor.zverovich@gmail.com>
#
#  Copyright:
#     Victor Zverovich, 2013
#
#  Last modified:
#     $Date: 2013-07-03 17:00:46 +0200 (Wed, 03 Jul 2013) $ by $Author: schulte $
#     $Revision: 13788 $
#
#  This file is part of Gecode, the generic constraint
#  development environment:
#     http://www.gecode.org
#
#  Permission is hereby granted, free of charge, to any person obtaining
#  a copy of this software and associated documentation files (the
#  "Software"), to deal in the Software without restriction, including
#  without limitation the rights to use, copy, modify, merge, publish,
#  distribute, sublicense, and/or sell copies of the Software, and to
#  permit persons to whom the Software is furnished to do so, subject to
#  the following conditions:
#
#  The above copyright notice and this permission notice shall be
#  included in all copies or substantial portions of the Software.
#
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
#  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
#  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
#  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
#  LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
#  OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
#  WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

#
# CMake build script for Gecode.
#

cmake_minimum_required(VERSION 2.6)

project(GECODE)

include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

include(CheckCXXCompilerFlag)
if (GECODE_DISABLE_WARNINGS)
  if (CMAKE_COMPILER_IS_GNUCXX)
    add_definitions(-Wno-overloaded-virtual)
    add_definitions(-Wno-switch)
    add_definitions(-Wno-unused-parameter)
    check_cxx_compiler_flag(
      -Wno-unused-but-set-variable HAVE_WNO_UNUSED_BUT_SET_VARIABLE_FLAG)
    if (HAVE_WNO_UNUSED_BUT_SET_VARIABLE_FLAG)
      add_definitions(-Wno-unused-but-set-variable)
    endif ()
  elseif (MSVC)
    foreach (flag_var
             CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
             CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      string(REPLACE "/W3" "/w" ${flag_var} "${${flag_var}}")
    endforeach()
  endif ()
endif ()

# The following part of config.h is hard to derive from configure.ac.
file(READ gecode/support/config.hpp.in CONFIG)
string(REGEX REPLACE "^/\\*([^*]|\\*[^/])*\\*/" "" CONFIG ${CONFIG})
string(REGEX MATCHALL "[^\n]*\n" CONFIG
"${CONFIG}
/* Define to 1 if you have the `getpagesize' function. */
#undef HAVE_GETPAGESIZE

/* Define to 1 if you have the <inttypes.h> header file. */
#undef HAVE_INTTYPES_H

/* Define to 1 if you have the <memory.h> header file. */
#undef HAVE_MEMORY_H

/* Define to 1 if you have a working `mmap' system call. */
#undef HAVE_MMAP

/* Define to 1 if you have the <stdint.h> header file. */
#undef HAVE_STDINT_H

/* Define to 1 if you have the <stdlib.h> header file. */
#undef HAVE_STDLIB_H

/* Define to 1 if you have the <strings.h> header file. */
#undef HAVE_STRINGS_H

/* Define to 1 if you have the <string.h> header file. */
#undef HAVE_STRING_H

/* Define to 1 if you have the <sys/param.h> header file. */
#undef HAVE_SYS_PARAM_H

/* Define to 1 if you have the <sys/stat.h> header file. */
#undef HAVE_SYS_STAT_H

/* Define to 1 if you have the <sys/types.h> header file. */
#undef HAVE_SYS_TYPES_H

/* Define to 1 if you have the <unistd.h> header file. */
#undef HAVE_UNISTD_H

/* Define to the address where bug reports for this package should be sent. */
#undef PACKAGE_BUGREPORT

/* Define to the full name of this package. */
#undef PACKAGE_NAME

/* Define to the full name and version of this package. */
#undef PACKAGE_STRING

/* Define to the one symbol short name of this package. */
#undef PACKAGE_TARNAME

/* Define to the home page for this package. */
#undef PACKAGE_URL

/* Define to the version of this package. */
#undef PACKAGE_VERSION

/* The size of `int', as computed by sizeof. */
#undef SIZEOF_INT

/* Define to 1 if you have the ANSI C header files. */
#undef STDC_HEADERS
")

# Get version numbers and parts of config.h from configure.ac.
file(READ configure.ac LINES)
# Replace semicolons with "<semi>" to avoid CMake messing with them.
string(REPLACE ";" "<semi>" LINES "${LINES}")
# Split into lines keeping newlines to avoid foreach skipping empty ones.
string(REGEX MATCHALL "[^\n]*\n" LINES "${LINES}")
set(ah_command FALSE)
foreach (line "${EXTRA_CONFIG}" ${LINES})
  string(REPLACE ";" "" line "${line}")
  if (ah_command)
    # Do nothing.
  elseif (line MATCHES "AC_INIT\\(([^,]*), *([^,]*), *([^)]*)\\)")
    set(PACKAGE ${CMAKE_MATCH_1})
    set(VERSION ${CMAKE_MATCH_2})
    set(PACKAGE_BUGREPORT ${CMAKE_MATCH_3})
    message(STATUS "Got VERSION=${VERSION} from configure.ac")
  elseif (line MATCHES "ac_gecode_flatzincversion=(.*)\n")
    set(GECODE_FLATZINC_VERSION "${CMAKE_MATCH_1}")
  elseif (line MATCHES "AH_BOTTOM\\(\\[(.*)")
    set(ah_command bottom)
    set(line "${CMAKE_MATCH_1}")
  elseif (line MATCHES "AH_VERBATIM[^,]+,(.*)")
    set(ah_command verbatim)
    set(line "${CMAKE_MATCH_1}")
  endif ()
  if (ah_command)
    set(saved_ah_command ${ah_command})
    if (line MATCHES "^\\[(.*)")
      set(line "${CMAKE_MATCH_1}")
    endif ()
    if (line MATCHES "\\]\\)")
      set(ah_command FALSE)
      string(REPLACE "])" "" line "${line}")
    endif ()
    # For some reason CMake may bundle several lines together. Split them too.
    string(REGEX MATCHALL "[^\n]*\n" sublines "${line}")
    set(config_add "")
    foreach (subline ${sublines})
      set(config_add ${config_add} "${subline}")
    endforeach ()
    if (saved_ah_command STREQUAL "verbatim")
      set(CONFIG ${config_add} ${CONFIG})
    else ()
      set(CONFIG ${CONFIG} "\n" ${config_add})
    endif ()
  endif ()
endforeach ()
set(PACKAGE_NAME ${PACKAGE})
string(TOLOWER ${PACKAGE} PACKAGE_TARNAME)
set(PACKAGE_URL "")
set(PACKAGE_VERSION ${VERSION})
set(${PACKAGE}_VERSION ${VERSION})
string(REPLACE "." "-" GECODE_LIBRARY_VERSION "${VERSION}")
set(PACKAGE_STRING "${PACKAGE} ${VERSION}")
if (VERSION MATCHES "(.*)\\.(.*)\\.(.*)")
  math(EXPR GECODE_VERSION_NUMBER
    "${CMAKE_MATCH_1} * 100000 + ${CMAKE_MATCH_2} * 100 + ${CMAKE_MATCH_3}")
endif ()

set(GECODE_DLL_USERPREFIX "")
set(GECODE_DLL_USERSUFFIX "")
set(GECODE_HAS_INT_VARS "/**/")
set(GECODE_HAS_SET_VARS "/**/")
set(GECODE_HAS_FLOAT_VARS "/**/")
set(GECODE_STATIC_LIBS 1)

check_cxx_compiler_flag(-fvisibility=hidden HAVE_VISIBILITY_HIDDEN_FLAG)
if (HAVE_VISIBILITY_HIDDEN_FLAG)
  set(GECODE_GCC_HAS_CLASS_VISIBILITY "/**/")
endif ()

if (WIN32)
  set(GECODE_THREADS_WINDOWS 1)
else ()
  set(GECODE_THREADS_PTHREADS 1)
endif ()

find_package(Qt4)
if (QT4_FOUND)
  set(GECODE_HAS_QT "/**/")
  set(GECODE_HAS_GIST "/**/")
  set(EXTRA_LIBS gist)
  include(${QT_USE_FILE})
endif ()

include(CheckSymbolExists)
check_symbol_exists(getpagesize unistd.h HAVE_GETPAGESIZE)
check_symbol_exists(mmap sys/mman.h HAVE_MMAP)

# Checks for header files.
include(CheckIncludeFiles)
foreach (header inttypes.h memory.h stdint.h stdlib.h strings.h string.h
                sys/param.h sys/stat.h sys/time.h sys/types.h unistd.h)
  string(TOUPPER HAVE_${header} var)
  string(REGEX REPLACE "\\.|/" "_" var ${var})
  check_include_files(${header} ${var})
endforeach ()
check_include_files(stdio.h STDC_HEADERS)
if (HAVE_SYS_TIME_H)
  set(GECODE_USE_GETTIMEOFDAY 1)
else ()
  set(GECODE_USE_CLOCK 1)
endif ()
if (HAVE_UNISTD_H)
  set(GECODE_HAS_UNISTD_H 1)
endif ()

include(CheckCXXSourceCompiles)
check_cxx_source_compiles("
   #include <ext/hash_map>
   int main() {}" HAVE_EXT_HASH_MAP)
if (HAVE_EXT_HASH_MAP)
  set(GECODE_HAS_GNU_HASH_MAP "/**/")
endif ()

include(CheckTypeSize)
check_type_size(int SIZEOF_INT)

# Check for inline.
include(CheckCSourceCompiles)
check_c_source_compiles("
  inline __attribute__ ((__always_inline__)) void foo(void) {}
  int main() {}" HAVE_ALWAYS_INLINE)
set(forceinline inline)
if (HAVE_ALWAYS_INLINE)
  set(forceinline "inline __attribute__ ((__always_inline__))")
endif ()

check_c_source_compiles("
  int main() { return __builtin_ffsl(0); }" HAVE_BUILTIN_FFSL)
if (HAVE_BUILTIN_FFSL)
  set(GECODE_HAS_BUILTIN_FFSL "/**/")
endif ()

# Process config.hpp using autoconf rules.
list(LENGTH CONFIG length)
math(EXPR length "${length} - 1")
foreach (i RANGE ${length})
  list(GET CONFIG ${i} line)
  if (line MATCHES "^#( *)undef (.*)\n")
    set(space "${CMAKE_MATCH_1}")
    set(var ${CMAKE_MATCH_2})
    if (NOT DEFINED ${var} OR (var MATCHES "HAVE_.*_H" AND NOT ${var}))
      set(line "/* #${space}undef ${var} */\n")
    else ()
      if ("${${var}}" STREQUAL "/**/" OR "${var}" STREQUAL "GECODE_VERSION_NUMBER" OR
          "${var}" STREQUAL "forceinline" OR var MATCHES "SIZEOF_.*")
        set(value ${${var}})
      elseif (NOT (var MATCHES ^HAVE OR ${var} EQUAL 0 OR ${var} EQUAL 1))
        set(value \"${${var}}\")
      elseif (${var})
        set(value 1)
      else ()
        set(value 0)
      endif ()
      set(line "#${space}define ${var} ${value}\n")
    endif ()
  endif ()
  string(REPLACE "<semi>" ";" line "${line}")
  set(CONFIG_OUT "${CONFIG_OUT}${line}")
endforeach ()
file(WRITE ${GECODE_BINARY_DIR}/gecode/support/config.hpp
"/* gecode/support/config.hpp.  Generated from config.hpp.in by configure.  */
/* gecode/support/config.hpp.in.  Generated from configure.ac by autoheader.  */

/* Disable autolink because all the dependencies are handled by CMake. */
#define GECODE_BUILD_SUPPORT
#define GECODE_BUILD_KERNEL
#define GECODE_BUILD_SEARCH
#define GECODE_BUILD_INT
#define GECODE_BUILD_SET
#define GECODE_BUILD_FLOAT
#define GECODE_BUILD_MINIMODEL

${CONFIG_OUT}")

# Expands a value substituting variables and appends the result to ${var}.
function (expand var value)
  if (value MATCHES "\\$\\(([^:]+)(.*)\\)")
    # Perform substitution.
    set(pattern ${CMAKE_MATCH_2})
    set(items ${${CMAKE_MATCH_1}})
    if (pattern MATCHES ":%=([^%]*)%([^%]*)")
      set(values )
      foreach (item ${items})
        set(values ${values} ${CMAKE_MATCH_1}${item}${CMAKE_MATCH_2})
      endforeach ()
    else ()
      set(values ${items})
    endif ()
  else ()
    set(values ${value})
  endif ()
  set(${var} ${${var}} ${values} PARENT_SCOPE)
endfunction ()

# Parse Makefile.in extracting variables.
file(READ Makefile.in text)
string(REPLACE "\\\n" "" text "${text}")
string(REGEX REPLACE "#[^\n]*\n" "" text "${text}")
string(REGEX MATCHALL "[^\n]+" lines "${text}")
foreach (line ${lines})
  if (line MATCHES "([^ \t]+)[ \t]*=[ \t]*(.*)")
    set(var ${CMAKE_MATCH_1})
    set(${var} )
    string(REGEX MATCHALL "[^ \t]+" items "${CMAKE_MATCH_2}")
    foreach (item ${items})
      expand(${var} ${item})
    endforeach ()
  endif ()
endforeach ()

foreach (lib support kernel search int set float
             minimodel driver flatzinc ${EXTRA_LIBS})
  if (lib STREQUAL "minimodel")
    set(libupper MM)
  else ()
    string(TOUPPER ${lib} libupper)
  endif ()
  if (${libupper}SRC)
    add_library(gecode${lib} ${${libupper}SRC} ${${libupper}HDR})
  endif ()
endforeach ()

find_package(Threads)
target_link_libraries(gecodesupport ${CMAKE_THREAD_LIBS_INIT})
target_link_libraries(gecodekernel gecodesupport)
target_link_libraries(gecodesearch gecodekernel)
target_link_libraries(gecodeint gecodekernel)
target_link_libraries(gecodeset gecodekernel)
target_link_libraries(gecodeminimodel gecodeint gecodeset gecodesearch)

if (GECODE_HAS_QT)
  target_link_libraries(gecodeflatzinc ${QT_LIBRARIES})
  target_link_libraries(gecodegist ${QT_LIBRARIES})
endif ()

if (FLOATSRC)
  target_link_libraries(gecodefloat gecodekernel)
  target_link_libraries(gecodeminimodel gecodefloat)
endif ()

add_executable(gecode-test ${TESTSRC} ${TESTHDR})
target_link_libraries(gecode-test gecodeminimodel)

enable_testing()
add_test(test gecode-test
  -iter 2 -test Branch::Int::Dense::3

=== debian/changelog ===
gecode (4.2.0-1) unstable; urgency=low

  * New upstream release (soname 35)
  * Bump debhelper compat to 9.

 -- Kari Pahula <kaol@debian.org>  Sat, 03 Aug 2013 21:00:55 +0300

=== debian/control ===
Source: gecode
Priority: optional
Maintainer: Kari Pahula <kaol@debian.org>
Build-Depends: debhelper (>= 9), autotools-dev, libqt4-dev, cdbs (>= 0.4.93~), dh-autoreconf, libmpfr-dev
Build-Depends-Indep: graphviz, doxygen
Standards-Version: 3.9.4
Section: libs
Homepage: http://www.gecode.org/

Package: libgecode-dev
Section: libdevel
Architecture: any
Depends: libgecode35 (= ${binary:Version}), libgecodegist35 (= ${binary:Version}), libgecodeflatzinc35 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libqt4-dev, libmpfr-dev
Suggests: libgecode-doc
Description: generic constraint development environment
 Gecode is a toolkit for developing constraint-based systems and
 applications. Gecode provides a constraint solver with
 state-of-the-art performance while being modular and extensible.
 .
 Gecode is radically open for programming: it can be easily
 interfaced to other systems. It supports the programming of new
 propagators (as implementation of constraints), branching strategies,
 and search engines. New variable domains can be programmed at the same
 level of efficiency as finite domain and integer set variables that
 come predefined with Gecode.

Package: libgecode-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libgecode-dev
Description: generic constraint development environment
 Gecode is a toolkit for developing constraint-based systems and
 applications. Gecode provides a constraint solver with
 state-of-the-art performance while being modular and extensible.
 .
 Gecode is radically open for programming: it can be easily
 interfaced to other systems. It supports the programming of new
 propagators (as implementation of constraints), branching strategies,
 and search engines. New variable domains can be programmed at the same
 level of efficiency as finite domain and integer set variables that
 come predefined with Gecode.
 .
 This package has the API documentation and examples.

Package: libgecode35
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Suggests: libgecode-dev
Description: generic constraint development environment
 Gecode is a toolkit for developing constraint-based systems and
 applications. Gecode provides a constraint solver with
 state-of-the-art performance while being modular and extensible.
 .
 Gecode is radically open for programming: it can be easily
 interfaced to other systems. It supports the programming of new
 propagators (as implementation of constraints), branching strategies,
 and search engines. New variable domains can be programmed at the same
 level of efficiency as finite domain and integer set variables that
 come predefined with Gecode.

Package: libgecodegist35
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Suggests: libgecode-dev
Description: Gecode Interactive Search Tool library
 Gecode is a toolkit for developing constraint-based systems and
 applications. Gecode provides a constraint solver with
 state-of-the-art performance while being modular and extensible.
 .
 This package contains libgecodegist, a graphical debugging tool, and
 libgecodedriver, a set of helper classes for writing standalone
 programs.  They have been separated from the main Gecode library
 package to avoid pulling in Qt as a dependency.

Package: libgecodeflatzinc35
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Suggests: libgecode-dev
Homepage: http://www.gecode.org/flatzinc.html
Description: Gecode support for FlatZinc modelling language
 Gecode is a toolkit for developing constraint-based systems and
 applications. Gecode provides a constraint solver with
 state-of-the-art performance while being modular and extensible.
 .
 FlatZinc is a low-level modelling language for constraint
 problems. It is designed to be easily interfaceable to constraint
 solvers (like Gecode). For more information on FlatZinc, please refer
 to the MiniZinc pages of the G12 project
 <http://www.g12.cs.mu.oz.au/minizinc/>.

Package: flatzinc
Section: devel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libgecode-dev (<< 3.7.0)
Homepage: http://www.gecode.org/flatzinc.html
Description: constraint problem modelling language
 FlatZinc is a low-level modelling language for constraint
 problems. It is designed to be easily interfaceable to constraint
 solvers (like Gecode). For more information on FlatZinc, please refer
 to the MiniZinc pages of the G12 project
 <http://www.g12.cs.mu.oz.au/minizinc/>.
 .
 We provide a parser that reads a FlatZinc model from a file, and
 returns a Gecode Space object that represents the model. We also
 provide a simple front-end, an executable program that reads a
 FlatZinc model and prints the solution (if any) on the standard
 output.
 .
 The FlatZinc interpreter that ships with Gecode version 4.2.0
 supports the FlatZinc language and MiniZinc global constraint
 definitions of MiniZinc version 1.6.0.

## gecode 4.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,8 +6,8 @@
 #     Victor Zverovich, 2013
 #
 #  Last modified:
-#     $Date: 2013-07-03 17:00:46 +0200 (Wed, 03 Jul 2013) $ by $Author: schulte $
-#     $Revision: 13788 $
+#     $Date: 2013-11-05 01:51:07 +0100 (Tue, 05 Nov 2013) $ by $Author: tack $
+#     $Revision: 14054 $
 #
 #  This file is part of Gecode, the generic constraint
 #  development environment:
@@ -37,7 +37,7 @@
 # CMake build script for Gecode.
 #
 
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.8)
 
 project(GECODE)
 
@@ -207,13 +207,22 @@
   set(GECODE_THREADS_PTHREADS 1)
 endif ()
 
-find_package(Qt4)
-if (QT4_FOUND)
-  set(GECODE_HAS_QT "/**/")
-  set(GECODE_HAS_GIST "/**/")
-  set(EXTRA_LIBS gist)
-  include(${QT_USE_FILE})
-endif ()
+find_package(Qt5 QUIET COMPONENTS Core Gui Widgets PrintSupport)
+if (Qt5_FOUND)
+   set(GECODE_HAS_QT "/**/")
+   set(GECODE_HAS_GIST "/**/")
+   set(EXTRA_LIBS gist)
+   set(CMAKE_AUTOMOC TRUE)
+else()
+  find_package(Qt4)
+  if (QT4_FOUND)
+    set(GECODE_HAS_QT "/**/")
+    set(GECODE_HAS_GIST "/**/")
+    set(EXTRA_LIBS gist)
+    set(CMAKE_AUTOMOC TRUE)
+    include(${QT_USE_FILE})
+  endif()
+endif()
 
 include(CheckSymbolExists)
 check_symbol_exists(getpagesize unistd.h HAVE_GETPAGESIZE)
@@ -272,7 +281,7 @@
   if (line MATCHES "^#( *)undef (.*)\n")
     set(space "${CMAKE_MATCH_1}")
     set(var ${CMAKE_MATCH_2})
-    if (NOT DEFINED ${var} OR (var MATCHES "HAVE_.*_H" AND NOT ${var}))
+    if (NOT DEFINED ${var} OR (var MATCHES "HAVE_.*" AND NOT ${var}))
       set(line "/* #${space}undef ${var} */\n")
     else ()
       if ("${${var}}" STREQUAL "/**/" OR "${var}" STREQUAL "GECODE_VERSION_NUMBER" OR
@@ -303,6 +312,9 @@
 #define GECODE_BUILD_SET
 #define GECODE_BUILD_FLOAT
 #define GECODE_BUILD_MINIMODEL
+#define GECODE_BUILD_FLATZINC
+#define GECODE_BUILD_DRIVER
+#define GECODE_BUILD_GIST
 
 ${CONFIG_OUT}")
 
@@ -350,7 +362,11 @@
     string(TOUPPER ${lib} libupper)
   endif ()
   if (${libupper}SRC)
-    add_library(gecode${lib} ${${libupper}SRC} ${${libupper}HDR})
+    set(sources ${${libupper}SRC})
+    if (${libupper}_GENSRC)
+      set(sources ${sources} ${${libupper}_GENSRC})
+    endif()
+    add_library(gecode${lib} ${sources} ${${libupper}HDR})
   endif ()
 endforeach ()
 
@@ -362,19 +378,3 @@
 target_link_libraries(gecodeset gecodekernel)
 target_link_libraries(gecodeminimodel gecodeint gecodeset gecodesearch)
 
-if (GECODE_HAS_QT)
-  target_link_libraries(gecodeflatzinc ${QT_LIBRARIES})
-  target_link_libraries(gecodegist ${QT_LIBRARIES})
-endif ()
-
-if (FLOATSRC)
-  target_link_libraries(gecodefloat gecodekernel)
-  target_link_libraries(gecodeminimodel gecodefloat)
-endif ()
-
-add_executable(gecode-test ${TESTSRC} ${TESTHDR})
-target_link_libraries(gecode-test gecodeminimodel)
-
-enable_testing()
-add_test(test gecode-test
-  -iter 2 -test Branch::Int::Dense::3

=== debian/changelog ===
gecode (4.2.1-1) unstable; urgency=low

  * New upstream release (soname 36)

 -- Kari Pahula <kaol@debian.org>  Sat, 09 Nov 2013 19:10:41 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 Package: libgecode-dev
 Section: libdevel
 Architecture: any
-Depends: libgecode35 (= ${binary:Version}), libgecodegist35 (= ${binary:Version}), libgecodeflatzinc35 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libqt4-dev, libmpfr-dev
+Depends: libgecode36 (= ${binary:Version}), libgecodegist36 (= ${binary:Version}), libgecodeflatzinc36 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libqt4-dev, libmpfr-dev
 Suggests: libgecode-doc
 Description: generic constraint development environment
  Gecode is a toolkit for developing constraint-based systems and
@@ -43,7 +43,7 @@
  .
  This package has the API documentation and examples.
 
-Package: libgecode35
+Package: libgecode36
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -61,7 +61,7 @@
  level of efficiency as finite domain and integer set variables that
  come predefined with Gecode.
 
-Package: libgecodegist35
+Package: libgecodegist36
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -77,7 +77,7 @@
  programs.  They have been separated from the main Gecode library
  package to avoid pulling in Qt as a dependency.
 
-Package: libgecodeflatzinc35
+Package: libgecodeflatzinc36
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f

DEB_CONFIGURE_EXTRA_FLAGS=--enable-gist --enable-qt --enable-float-vars --disable-examples --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
DEB_BUILD_PARALLEL=yes
DEB_MAKE_CHECK_TARGET=check LD_LIBRARY_PATH=.
DEB_DH_BUILDDEB_ARGS=-- -Zxz

include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/autoreconf.mk

ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS))$(filter ia64 mipsel,$(DEB_HOST_ARCH)))
	CFLAGS += -O3
	CXXFLAGS += -O3
endif

CFLAGS += -D_REENTRANT $(CPPFLAGS)
CXXFLAGS += -D_REENTRANT $(CPPFLAGS)
DEB_CONFIGURE_EXTRA_FLAGS += DLLFLAGS="$(LDFLAGS)" GLDFLAGS="$(LDFLAGS)"

ChangeLog:
	$(MAKE) ChangeLog

common-install-prehook-impl:: ChangeLog

build/libgecode-doc::
	$(MAKE) doc

binary-fixup/libgecode-doc::
	find $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-doc/examples/ -type f -exec chmod 0644 '{}' ';'
	install -m 0644 -D debian/Makefile.examples $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-doc/examples/Makefile

binary-fixup/libgecode-dev::
	find $(CURDIR)/debian/libgecode-dev/usr/include -type f -exec chmod -x {} \;

common-binary-fixup-arch::
	for libso in `find debian/ -type f -regex 'debian/lib.*/lib.*\.so\.[0-9]+\.[0-9]+'`; do ln -s $${libso##*/} $${libso%.*}; done

binary/libgecode-doc::
	[ -e debian/libgecode-doc/usr/share/doc/libgecode-doc/html/ ]

## gecode 4.4.0

=== examples/CMakeLists.txt ===
#
#  Main authors:
#     Petter Strandmark <petter.strandmark@gmail.com>
#
#  Copyright:
#     Petter Strandmark, 2014
#
#  Last modified:
#     $Date: 2014-10-03 12:13:17 +0200 (Fri, 03 Oct 2014) $ by $Author: schulte $
#     $Revision: 14239 $
#
#  This file is part of Gecode, the generic constraint
#  development environment:
#     http://www.gecode.org
#
#  Permission is hereby granted, free of charge, to any person obtaining
#  a copy of this software and associated documentation files (the
#  "Software"), to deal in the Software without restriction, including
#  without limitation the rights to use, copy, modify, merge, publish,
#  distribute, sublicense, and/or sell copies of the Software, and to
#  permit persons to whom the Software is furnished to do so, subject to
#  the following conditions:
#
#  The above copyright notice and this permission notice shall be
#  included in all copies or substantial portions of the Software.
#
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
#  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
#  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
#  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
#  LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
#  OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
#  WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

#
# CMake build script for Gecode examples.
#

if (MSVC)
	# Needed for some examples to prevent
	# C1128: number of sections exceeded object file format limit : compile with /bigobj
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
endif()

macro (GECODE_EXAMPLE NAME)
	add_executable(${NAME}${EXECUTABLE_EXTENSION}
	               ${NAME}.cpp)
	target_link_libraries(${NAME}${EXECUTABLE_EXTENSION} gecodeminimodel gecodedriver)
	set_property(TARGET ${NAME}${EXECUTABLE_EXTENSION}         PROPERTY FOLDER "Examples")
endmacro ()

file(GLOB EXAMPLE_FILES *.cpp)
foreach (EXAMPLE_FILE ${EXAMPLE_FILES})
	get_filename_component(EXAMPLE_NAME ${EXAMPLE_FILE} NAME_WE)
	message("-- Adding example: " ${EXAMPLE_NAME})
	gecode_example(${EXAMPLE_NAME})
endforeach()

=== debian/changelog ===
gecode (4.4.0-3) unstable; urgency=medium

  * Library transition for GCC 5 (Closes: #791042)
    * Change library package name suffix to 41v5.

 -- Kari Pahula <kaol@debian.org>  Sun, 19 Jul 2015 18:32:00 +0300

gecode (4.4.0-2) unstable; urgency=medium

  * Switch over to Qt5.

 -- Kari Pahula <kaol@debian.org>  Thu, 07 May 2015 21:51:44 +0300

gecode (4.4.0-1) unstable; urgency=medium

  * New upstream release (soname 41)
  * Standards-Version 3.9.6 (no changes necessary).
  * Drop patch fix-powerpcspe.patch, as it is included upstream.
  * Add flex and bison to build deps and patch gecode.m4 to correctly
    recognize bison 3 and add a required declaration to parser.yxx.
  * Scrub a doxygen-added copy of jquery from libgecode-doc.  It's not
    used by any of its html files.

 -- Kari Pahula <kaol@debian.org>  Fri, 01 May 2015 09:37:57 +0300

gecode (4.2.1-2) unstable; urgency=medium

  * Fix FTBFS on powerpcspe. (Closes: #730089)
  * Standards-Version 3.9.5 (no changes necessary).

 -- Kari Pahula <kaol@debian.org>  Tue, 16 Sep 2014 20:30:43 +0300

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,16 @@
 Source: gecode
 Priority: optional
 Maintainer: Kari Pahula <kaol@debian.org>
-Build-Depends: debhelper (>= 9), autotools-dev, libqt4-dev, cdbs (>= 0.4.93~), dh-autoreconf, libmpfr-dev
+Build-Depends: debhelper (>= 9), autotools-dev, cdbs (>= 0.4.93~), dh-autoreconf, libmpfr-dev, flex, bison, qtbase5-dev
 Build-Depends-Indep: graphviz, doxygen
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Section: libs
 Homepage: http://www.gecode.org/
 
 Package: libgecode-dev
 Section: libdevel
 Architecture: any
-Depends: libgecode36 (= ${binary:Version}), libgecodegist36 (= ${binary:Version}), libgecodeflatzinc36 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libqt4-dev, libmpfr-dev
+Depends: libgecode41v5 (= ${binary:Version}), libgecodegist41v5 (= ${binary:Version}), libgecodeflatzinc41v5 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, qtbase5-dev, libmpfr-dev
 Suggests: libgecode-doc
 Description: generic constraint development environment
  Gecode is a toolkit for developing constraint-based systems and
@@ -27,7 +27,7 @@
 Package: libgecode-doc
 Section: doc
 Architecture: all
-Depends: ${misc:Depends}
+Depends: ${misc:Depends}, libjs-jquery
 Suggests: libgecode-dev
 Description: generic constraint development environment
  Gecode is a toolkit for developing constraint-based systems and
@@ -43,12 +43,14 @@
  .
  This package has the API documentation and examples.
 
-Package: libgecode36
+Package: libgecode41v5
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Suggests: libgecode-dev
+Replaces: libgecode41
+Breaks: libgecode41
 Description: generic constraint development environment
  Gecode is a toolkit for developing constraint-based systems and
  applications. Gecode provides a constraint solver with
@@ -61,12 +63,14 @@
  level of efficiency as finite domain and integer set variables that
  come predefined with Gecode.
 
-Package: libgecodegist36
+Package: libgecodegist41v5
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Suggests: libgecode-dev
+Replaces: libgecodegist41
+Breaks: libgecodegist41
 Description: Gecode Interactive Search Tool library
  Gecode is a toolkit for developing constraint-based systems and
  applications. Gecode provides a constraint solver with
@@ -77,12 +81,14 @@
  programs.  They have been separated from the main Gecode library
  package to avoid pulling in Qt as a dependency.
 
-Package: libgecodeflatzinc36
+Package: libgecodeflatzinc41v5
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Suggests: libgecode-dev
+Replaces: libgecodeflatzinc41
+Breaks: libgecodeflatzinc41
 Homepage: http://www.gecode.org/flatzinc.html
 Description: Gecode support for FlatZinc modelling language
  Gecode is a toolkit for developing constraint-based systems and
@@ -114,6 +120,6 @@
  FlatZinc model and prints the solution (if any) on the standard
  output.
  .
- The FlatZinc interpreter that ships with Gecode version 4.2.0
+ The FlatZinc interpreter that ships with Gecode version 4.4.0
  supports the FlatZinc language and MiniZinc global constraint
  definitions of MiniZinc version 1.6.0.

=== debian/rules ===
--- 
+++ 
@@ -1,9 +1,10 @@
 #!/usr/bin/make -f
 
-DEB_CONFIGURE_EXTRA_FLAGS=--enable-gist --enable-qt --enable-float-vars --disable-examples --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
+DEB_CONFIGURE_EXTRA_FLAGS=--enable-gist --enable-qt --enable-float-vars --disable-examples --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) QT_SELECT=5
 DEB_BUILD_PARALLEL=yes
 DEB_MAKE_CHECK_TARGET=check LD_LIBRARY_PATH=.
 DEB_DH_BUILDDEB_ARGS=-- -Zxz
+DEB_MAKE_ENVVARS=QT_SELECT=5
 
 include /usr/share/cdbs/1/class/autotools.mk
 include /usr/share/cdbs/1/rules/debhelper.mk
@@ -29,9 +30,11 @@
 binary-fixup/libgecode-doc::
 	find $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-doc/examples/ -type f -exec chmod 0644 '{}' ';'
 	install -m 0644 -D debian/Makefile.examples $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-doc/examples/Makefile
+	rm -f $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-doc/html/jquery.js
 
 binary-fixup/libgecode-dev::
 	find $(CURDIR)/debian/libgecode-dev/usr/include -type f -exec chmod -x {} \;
+	rm -f $(CURDIR)/debian/libgecode-dev/usr/include/gecode/third-party/boost/LICENSE_1_0.txt
 
 common-binary-fixup-arch::
 	for libso in `find debian/ -type f -regex 'debian/lib.*/lib.*\.so\.[0-9]+\.[0-9]+'`; do ln -s $${libso##*/} $${libso%.*}; done

## gecode 5.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,8 +6,8 @@
 #     Victor Zverovich, 2013
 #
 #  Last modified:
-#     $Date: 2013-11-05 01:51:07 +0100 (Tue, 05 Nov 2013) $ by $Author: tack $
-#     $Revision: 14054 $
+#     $Date: 2016-09-06 17:50:13 +0200 (Tue, 06 Sep 2016) $ by $Author: tack $
+#     $Revision: 15165 $
 #
 #  This file is part of Gecode, the generic constraint
 #  development environment:
@@ -41,26 +41,21 @@
 
 project(GECODE)
 
-include_directories(${CMAKE_CURRENT_BINARY_DIR})
-include_directories(${CMAKE_CURRENT_SOURCE_DIR})
+set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
 
 include(CheckCXXCompilerFlag)
 if (GECODE_DISABLE_WARNINGS)
-  if (CMAKE_COMPILER_IS_GNUCXX)
-    add_definitions(-Wno-overloaded-virtual)
-    add_definitions(-Wno-switch)
-    add_definitions(-Wno-unused-parameter)
-    check_cxx_compiler_flag(
-      -Wno-unused-but-set-variable HAVE_WNO_UNUSED_BUT_SET_VARIABLE_FLAG)
-    if (HAVE_WNO_UNUSED_BUT_SET_VARIABLE_FLAG)
-      add_definitions(-Wno-unused-but-set-variable)
-    endif ()
-  elseif (MSVC)
-    foreach (flag_var
-             CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
-             CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
-      string(REPLACE "/W3" "/w" ${flag_var} "${${flag_var}}")
-    endforeach()
+  if (MSVC)
+    add_definitions(/wd4244 /wd4267 /wd4345 /wd4355 /wd4800)
+  else ()
+    foreach (flag -Wextra -Wall -pedantic)
+      string(REPLACE ${flag} "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
+    endforeach ()
+    if (CMAKE_COMPILER_IS_GNUCXX)
+      add_definitions(-Wno-overloaded-virtual)
+    elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
+      add_definitions(-Wno-constant-logical-operand -Wno-switch)
+    endif ()
   endif ()
 endif ()
 
@@ -195,6 +190,7 @@
 set(GECODE_HAS_SET_VARS "/**/")
 set(GECODE_HAS_FLOAT_VARS "/**/")
 set(GECODE_STATIC_LIBS 1)
+set(GECODE_ALLOCATOR "/**/")
 
 check_cxx_compiler_flag(-fvisibility=hidden HAVE_VISIBILITY_HIDDEN_FLAG)
 if (HAVE_VISIBILITY_HIDDEN_FLAG)
@@ -207,22 +203,25 @@
   set(GECODE_THREADS_PTHREADS 1)
 endif ()
 
-find_package(Qt5 QUIET COMPONENTS Core Gui Widgets PrintSupport)
-if (Qt5_FOUND)
-   set(GECODE_HAS_QT "/**/")
-   set(GECODE_HAS_GIST "/**/")
-   set(EXTRA_LIBS gist)
-   set(CMAKE_AUTOMOC TRUE)
-else()
-  find_package(Qt4)
-  if (QT4_FOUND)
-    set(GECODE_HAS_QT "/**/")
-    set(GECODE_HAS_GIST "/**/")
-    set(EXTRA_LIBS gist)
-    set(CMAKE_AUTOMOC TRUE)
-    include(${QT_USE_FILE})
+# Don't use Qt if GECODE_USE_QT is set to FALSE.
+if (NOT DEFINED GECODE_USE_QT OR GECODE_USE_QT)
+  find_package(Qt5 QUIET COMPONENTS Core Gui Widgets PrintSupport)
+  if (Qt5_FOUND)
+     set(GECODE_HAS_QT "/**/")
+     set(GECODE_HAS_GIST "/**/")
+     set(EXTRA_LIBS gist)
+     set(CMAKE_AUTOMOC TRUE)
+  else()
+    find_package(Qt4)
+    if (QT4_FOUND)
+      set(GECODE_HAS_QT "/**/")
+      set(GECODE_HAS_GIST "/**/")
+      set(EXTRA_LIBS gist)
+      set(CMAKE_AUTOMOC TRUE)
+      include(${QT_USE_FILE})
+    endif()
   endif()
-endif()
+endif ()
 
 include(CheckSymbolExists)
 check_symbol_exists(getpagesize unistd.h HAVE_GETPAGESIZE)
@@ -362,19 +361,20 @@
     string(TOUPPER ${lib} libupper)
   endif ()
   if (${libupper}SRC)
-    set(sources ${${libupper}SRC})
-    if (${libupper}_GENSRC)
-      set(sources ${sources} ${${libupper}_GENSRC})
-    endif()
+    set(sources )
+    foreach (src ${${libupper}SRC} ${${libupper}_GENSRC})
+      if ((src STREQUAL "gecode/support/thread/pthreads.cpp" AND MSVC) OR
+           src STREQUAL "gecode/float/rounding.cpp")
+        # ignore empty source files to prevent linker warnings
+      else ()
+        set(sources ${sources} ${src})
+      endif ()
+    endforeach ()
     add_library(gecode${lib} ${sources} ${${libupper}HDR})
+    target_include_directories(gecode${lib}
+      PUBLIC ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
   endif ()
 endforeach ()
 
 find_package(Threads)
 target_link_libraries(gecodesupport ${CMAKE_THREAD_LIBS_INIT})
-target_link_libraries(gecodekernel gecodesupport)
-target_link_libraries(gecodesearch gecodekernel)
-target_link_libraries(gecodeint gecodekernel)
-target_link_libraries(gecodeset gecodekernel)
-target_link_libraries(gecodeminimodel gecodeint gecodeset gecodesearch)
-

=== contribs/quacode/CMakeLists.txt ===
#
# Main authors:
#    Vincent Barichard <Vincent.Barichard@univ-angers.fr>
#
# Copyright:
#    Vincent Barichard, 2013
#
# Last modified:
#    $Date: 2015-12-08 17:50:36 +0100 (Tue, 08 Dec 2015) $ by $Author: vbarichard $
#    $Revision: 14846 $
#
# This file is part of Quacode:
#    http://quacode.barichard.com
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

SET(GECODE_SRC "${CMAKE_SOURCE_DIR}/../.." CACHE PATH "Path where GeCode source is installed")
SET(GECODE_BIN "${GECODE_SRC}" CACHE PATH "Path where GeCode libs and binaries are installed")
SET(BUILD_EXAMPLES ON CACHE BOOL "Build examples or not")

# If the user specifies -DCMAKE_BUILD_TYPE on the command line, take their definition
# and dump it in the cache along with proper documentation, otherwise set CMAKE_BUILD_TYPE
# to Debug prior to calling PROJECT()
#
IF(NOT DEFINED CMAKE_BUILD_TYPE)
  # Check if Gecode is configured with --enable-debug
  FILE(STRINGS ${GECODE_BIN}/config.status GECODE_DEBUG_BUILD REGEX "S\\[\"DEBUG_BUILD\"\\]=")
  IF(GECODE_DEBUG_BUILD MATCHES "yes")
    SET(QUACODE_BUILD_TYPE "Debug")
  ELSE()
    SET(QUACODE_BUILD_TYPE "Release")
  ENDIF()

   SET(CMAKE_BUILD_TYPE "${QUACODE_BUILD_TYPE}" CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel.")
ENDIF()

PROJECT(Quacode)
SET(CMAKE_CXX_FLAGS "-std=c++11")

SET(CMAKE_VERBOSE_MAKEFILE TRUE)

# Check if Gecode is configured with --enable-audit
FILE(STRINGS ${GECODE_BIN}/config.status GECODE_AUDIT REGEX "D\\[\"GECODE_AUDIT\"\\]=")
IF(GECODE_AUDIT)
  SET(QUACODE_AUDIT TRUE)
ELSE()
  SET(QUACODE_AUDIT FALSE)
ENDIF()
SET(LOG_AUDIT ${QUACODE_AUDIT} CACHE BOOL "Set to true to generate log output.")

IF(UNIX)
  # determine, whether we want a static binary
  SET(STATIC_LINKING FALSE CACHE BOOL "Build a static binary?")
  # do we want static libraries?
  IF(STATIC_LINKING)
    SET(BUILD_SHARED_LIBS OFF)
    # To know in source file that we compil static
    ADD_DEFINITIONS(-DQUACODE_STATIC_LIBS)
    # When STATIC_LINKING is TRUE, than cmake looks for libraries ending
    # with .a. This is for linux only!
    SET(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
    SET(CMAKE_EXE_LINKER_FLAGS "-static")
    # Remove flags to get rid off all the -Wl,Bydnamic
    SET(CMAKE_EXE_LINK_DYNAMIC_C_FLAGS)
    SET(CMAKE_EXE_LINK_DYNAMIC_CXX_FLAGS)
    # Use static libs for Boost
    SET(Boost_USE_STATIC_LIBS ON)
    SET(Boost_USE_STATIC_RUNTIME ON)
  ELSE(STATIC_LINKING)
    SET(BUILD_SHARED_LIBS ON)
  ENDIF(STATIC_LINKING)
ELSE(UNIX)
  SET(BUILD_SHARED_LIBS ON)
ENDIF(UNIX)

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_MODULE_PATH})
FIND_PACKAGE(Gecode)

IF(NOT GECODE_FOUND)
  MESSAGE(FATAL_ERROR "Gecode is needed, consider to install it")
ELSE (NOT GECODE_FOUND)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
  INCLUDE_DIRECTORIES(${GECODE_BIN})
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
  INCLUDE_DIRECTORIES(${GECODE_SRC})

  LINK_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
  LINK_DIRECTORIES(${GECODE_BIN})

  IF (CMAKE_COMPILER_IS_GNUCXX)
    ADD_DEFINITIONS(-Wall)
    ADD_DEFINITIONS(-Wextra)
    ADD_DEFINITIONS(-Wno-unused-local-typedefs)
    ADD_DEFINITIONS(-fimplement-inlines)
    ADD_DEFINITIONS(-fno-inline-functions)
    ADD_DEFINITIONS(-pipe)
    ADD_DEFINITIONS(-fPIC)
    SET(CMAKE_CXX_FLAGS_DEBUG "-ggdb")
  ENDIF ()

  IF (LOG_AUDIT)
    ADD_DEFINITIONS(-DLOG_AUDIT)
  ENDIF()

  INCLUDE(CheckCXXCompilerFlag)
  check_cxx_compiler_flag(-fvisibility=hidden HAVE_VISIBILITY_HIDDEN_FLAG)
  IF (HAVE_VISIBILITY_HIDDEN_FLAG)
    ADD_DEFINITIONS(-fvisibility=hidden)
    ADD_DEFINITIONS(-DQUACODE_GCC_HAS_CLASS_VISIBILITY)
  ENDIF()

  FIND_PACKAGE(Threads)

  SET(QUACODE_HEADERS
    quacode/qcsp.hh
    quacode/qspaceinfo.hh
    quacode/support/dynamic-list.hh
    quacode/support/log.hh
    quacode/search/sequential/qpath.hh
    quacode/search/sequential/qdfs.hh
    quacode/qint/qbool.hh
  )
  SET(QUACODE_HPP
    quacode/qspaceinfo.hpp
    quacode/search/qdfs.hpp
    quacode/qint/watch.hpp
    quacode/qint/qbool/clause.hpp
    quacode/qint/qbool/eq.hpp
    quacode/qint/qbool/eqv.hpp
    quacode/qint/qbool/or.hpp
    quacode/qint/qbool/xor.hpp
    quacode/qint/qbool/xorv.hpp
  )
  SET(QUACODE_SRCS
    quacode/qspaceinfo.cpp
    quacode/support/log.cpp
    quacode/search/qdfs.cpp
    quacode/search/sequential/qpath.cpp
    quacode/qint/qbool/qbool.cpp
    ${GECODE_SRC}/gecode/search/meta/nogoods.cpp
  )
  SET(QUACODE_EXAMPLES_SRCS
    examples/qbf.cpp
    examples/qdimacs.cpp
    examples/nim-fibo.cpp
    examples/matrix-game.cpp
    examples/connect-four.cpp
    examples/baker.cpp
    examples/rndQCSP.cpp
  )

  SOURCE_GROUP("Hpp Files" REGULAR_EXPRESSION ".hpp")

  SET_SOURCE_FILES_PROPERTIES(${ALL_HEADERS} PROPERTIES HEADER_FILE_ONLY TRUE)
  SET_SOURCE_FILES_PROPERTIES(${ALL_HPP} PROPERTIES HEADER_FILE_ONLY TRUE)

  ADD_LIBRARY(quacode ${QUACODE_SRCS} ${QUACODE_HEADERS} ${QUACODE_HPP})
  TARGET_LINK_LIBRARIES(quacode ${GECODE_LIBRARIES})
  SET_TARGET_PROPERTIES(quacode PROPERTIES COMPILE_DEFINITIONS "BUILD_QUACODE_LIB")
  INSTALL(TARGETS quacode LIBRARY DESTINATION lib ARCHIVE DESTINATION lib/static)
  SET(QUACODE_LIBRARIES quacode)

  IF(BUILD_EXAMPLES)
    # Add targets for examples
    FOREACH (example ${QUACODE_EXAMPLES_SRCS})
      GET_FILENAME_COMPONENT(exampleBin ${example} NAME_WE)
      ADD_EXECUTABLE(${exampleBin} ${example})
      TARGET_LINK_LIBRARIES(${exampleBin} ${QUACODE_LIBRARIES} ${GECODE_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
      INSTALL(TARGETS ${exampleBin} RUNTIME DESTINATION bin)

      # set -static, when STATIC_LINKING is TRUE and set LINK_SEARCH_END_STATIC
      # to remove the additional -bdynamic from the linker line.
      IF(UNIX AND STATIC_LINKING)
          SET(CMAKE_EXE_LINKER_FLAGS "-static")
          SET_TARGET_PROPERTIES(${exampleBin} PROPERTIES LINK_SEARCH_END_STATIC 1)
      ENDIF(UNIX AND STATIC_LINKING)
    ENDFOREACH ()
  ENDIF(BUILD_EXAMPLES)

ENDIF(NOT GECODE_FOUND)

=== debian/changelog ===
gecode (5.1.0-2build1) bionic; urgency=medium

  * No-change rebuild for mpfr soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 24 Jan 2018 21:22:26 +0000

gecode (5.1.0-2) unstable; urgency=medium

  * Use Debian's own Boost instead of the one included with Gecode.
    (Closes: #869696)
  * Pass --with-host-os=linux to configure to always use host_os=linux.
    (Closes: #869699)

 -- Kari Pahula <kaol@debian.org>  Sat, 29 Jul 2017 15:41:24 +0300

gecode (5.1.0-1) unstable; urgency=medium

  * New upstream release (soname 44)
    - fzn-gecode seems to work correctly now. (Closes: #861949)
  * Standards-Version 4.0.0 (no changes necessary).
  * Drop patch bison-3-support since upstream updated their build with
    similar change.
  * Remove mzn-gecode from flatzinc since mzn-fzn provided by minizinc
    provides that functionality.
  * Remove /usr/share/gecode/mznlib from flatzinc since minizinc comes
    with its own copy of it.
  * Add symlink /usr/bin/flatzinc to fzn-gecode.
  * Add recommends on minizinc to flatzinc.

 -- Kari Pahula <kaol@debian.org>  Tue, 18 Jul 2017 21:41:42 +0300

gecode (4.4.0-5) unstable; urgency=medium

  * Fix possible FTBFS with parallel invocation of bison and mv.  (Thanks
    to Adrian Bunk <bunk@debian.org>) (Closes: #863936)

 -- Kari Pahula <kaol@debian.org>  Fri, 02 Jun 2017 23:49:43 +0300

gecode (4.4.0-4) unstable; urgency=medium

  * Fix FTBFS on ppc64el on conversion of long long unsigned int to
    signed.  (Thanks to John Paul Adrian Glaubitz
    <glaubitz@physik.fu-berlin.de>) (Closes: #858132)
  * Add Build-Conflicts: libqt4-dev to force Qt5 usage.
  * Add some lintian overrides for false positives on typo checking.

 -- Kari Pahula <kaol@debian.org>  Sun, 19 Mar 2017 10:30:25 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: gecode
 Priority: optional
 Maintainer: Kari Pahula <kaol@debian.org>
-Build-Depends: debhelper (>= 9), autotools-dev, cdbs (>= 0.4.93~), dh-autoreconf, libmpfr-dev, flex, bison, qtbase5-dev
+Build-Depends: debhelper (>= 9), autotools-dev, cdbs (>= 0.4.93~), dh-autoreconf, libmpfr-dev, flex, bison, qtbase5-dev, libboost-dev
 Build-Depends-Indep: graphviz, doxygen
-Standards-Version: 3.9.6
+Build-Conflicts: libqt4-dev
+Standards-Version: 4.0.0
 Section: libs
 Homepage: http://www.gecode.org/
 
 Package: libgecode-dev
 Section: libdevel
 Architecture: any
-Depends: libgecode41v5 (= ${binary:Version}), libgecodegist41v5 (= ${binary:Version}), libgecodeflatzinc41v5 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, qtbase5-dev, libmpfr-dev
+Depends: libgecode44 (= ${binary:Version}), libgecodegist44 (= ${binary:Version}), libgecodeflatzinc44 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, qtbase5-dev, libmpfr-dev, libboost-dev
 Suggests: libgecode-doc
 Description: generic constraint development environment
  Gecode is a toolkit for developing constraint-based systems and
@@ -43,14 +44,12 @@
  .
  This package has the API documentation and examples.
 
-Package: libgecode41v5
+Package: libgecode44
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Suggests: libgecode-dev
-Replaces: libgecode41
-Breaks: libgecode41
 Description: generic constraint development environment
  Gecode is a toolkit for developing constraint-based systems and
  applications. Gecode provides a constraint solver with
@@ -63,14 +62,12 @@
  level of efficiency as finite domain and integer set variables that
  come predefined with Gecode.
 
-Package: libgecodegist41v5
+Package: libgecodegist44
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Suggests: libgecode-dev
-Replaces: libgecodegist41
-Breaks: libgecodegist41
 Description: Gecode Interactive Search Tool library
  Gecode is a toolkit for developing constraint-based systems and
  applications. Gecode provides a constraint solver with
@@ -81,14 +78,12 @@
  programs.  They have been separated from the main Gecode library
  package to avoid pulling in Qt as a dependency.
 
-Package: libgecodeflatzinc41v5
+Package: libgecodeflatzinc44
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Suggests: libgecode-dev
-Replaces: libgecodeflatzinc41
-Breaks: libgecodeflatzinc41
 Homepage: http://www.gecode.org/flatzinc.html
 Description: Gecode support for FlatZinc modelling language
  Gecode is a toolkit for developing constraint-based systems and
@@ -105,6 +100,7 @@
 Section: devel
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Recommends: minizinc
 Replaces: libgecode-dev (<< 3.7.0)
 Homepage: http://www.gecode.org/flatzinc.html
 Description: constraint problem modelling language

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-DEB_CONFIGURE_EXTRA_FLAGS=--enable-gist --enable-qt --enable-float-vars --disable-examples --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) QT_SELECT=5
+DEB_CONFIGURE_EXTRA_FLAGS=--enable-gist --enable-qt --enable-float-vars --disable-examples --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) QT_SELECT=5 --with-host-os=linux
 DEB_BUILD_PARALLEL=yes
 DEB_MAKE_CHECK_TARGET=check LD_LIBRARY_PATH=.
 DEB_DH_BUILDDEB_ARGS=-- -Zxz
